      subroutine coast(xplot,yplot,ltype,
     +                 xmin,xmax,ymin,ymax,xorigo,yorigo,clbase)
c
#include "comlog.inc"
#include "dimpar.inc"

      real xplot(1000),yplot(1000)
      integer ltype
      real xmin,xmax,ymin,ymax,xorigo,yorigo
      character*1 clbase
c
#include "comrep.inc"
c
#include "comdef.inc"
c
#include "comnew.inc"
c
      character*128 filnam
      logical dline
c
c**************************************************************************
c
      pi     = 4.*atan(1.)
      zradi = pi/180.
      rearth = 6.371e+06
      eps = 0.0001
      dline = .false.
c
c**************************************************************************
c
c    select the proper coastline file
c
      call mkcoast(clbase)
      call clname(clbase,filnam)
c
      open(unit=18,file=filnam,
     +     form='unformatted',status='old',iostat=ios)
      if(ios.ne.0)then
         write(lulog,*)' file ',filnam
         write(lulog,*)' open error. iostat=',ios
         return
      endif

c
      rewind(unit=18)
c
c******************************************************************************
c
c      map projection is polar stereographic
c
      if( maprep.eq.5 ) then
c
         zprola = prolat*zradi
         if( prolat.ge.0. ) then
            zrlen = ( 1. + sin(zprola))*rearth/(scale*1.e+6)*100.
         else
            zrlen = ( 1. - sin(zprola))*rearth/(scale*1.e+6)*100.
         endif
         zlatm  = latmid*zradi
         zlonm  = (lonmid-prolon)*zradi
         if( prolat.ge.0. ) then
            zrmid = zrlen*cos(zlatm)/(1.+sin(zlatm))
         else
            zrmid = zrlen*cos(zlatm)/(1.-sin(zlatm))
            zlonm = -zlonm
         endif
         zyor = - zrmid*cos(zlonm) - 0.5*dymap
         zxor =   zrmid*sin(zlonm) - 0.5*dxmap
         zxadd = - zxor + 1.5e-5 + xorigo
         zyadd = - zyor + 1.5e-5 + yorigo
         zfac = 1./(scale*1.e+6)*100.
c
c
c------------------------------------------------------------------------------
c
c      map projection is mercator
c
      else if( maprep.eq.1 ) then
c
         zfac = 1./(scale*1.e+6)*100.
         zprola = prolat*zradi
         zlatm  = latmid*zradi
         zlonm  = lonmid*zradi
         if( zlonm.gt.pi ) zlonm = zlonm - 2.*pi
         zmult = rearth*cos(zprola)/(scale*1.e+6)*100.
         zxor = zmult*zlonm - 0.5*dxmap
         zyor = zmult*alog( (1.+sin(zlatm))/cos(zlatm) ) - 0.5*dymap
         if( zxor/zmult.lt.-pi ) then
            zlonm = zlonm + 2.*pi
            zxor = zmult*zlonm - 0.5*dxmap
            dline = .true.
         else if( (zxor+dxmap)/zmult.gt.pi ) then
            dline = .true.
         endif
         if( dline ) then
            zxlim = lonmid + 180.
            if( zxlim.gt.180. ) zxlim = zxlim - 360.
            zxlim = zmult*zradi*zxlim/zfac
            zxplus = 2.*pi*zmult/zfac
         endif
         zxadd = - zxor + 1.5e-5 + xorigo
         zyadd = - zyor + 1.5e-5 + yorigo
c
c------------------------------------------------------------------------------
c
c         map projection is regular lat/long
c
      else if( maprep.eq.0 ) then
c
         if( ( irep.eq.0 .or.
     x         (irep.eq.10.and.alatnp.gt.89.9) ) .and. ltotal ) then
c
            zfac = zradi*rearth/(scale*1.e+6)*100.0
            zlomin = alonw
            zlamin = alats
            zxadd =  1.5e-5 + xorigo - zlomin*zfac
            zyadd =  1.5e-5 + yorigo - zlamin*zfac
c
         else if ( irep.eq.04 .and. ltotal) then
c
            zfac = zradi*rearth/(scale*1.e+6)*100.0
            zlomin = alonw
            zlamin = gaulat(jsgaus)
            zxadd =  1.5e-5 + xorigo - zlomin*zfac
            zyadd =  1.5e-5 + yorigo - zlamin*zfac
c
         else
c
            zfac = zradi*rearth/(scale*1.e+6)*100.0
            zlomin = lonmid - 0.5*dxmap/zfac
            zlomax = lonmid + 0.5*dxmap/zfac
            if( zlomin.lt.-180. ) then
               zlomin = zlomin + 360.
               dline = .true.
            else if( zlomax.gt.180. ) then
               dline = .true.
            endif
            if( dline ) then
               zxlim = lonmid + 180.
               if( zxlim.gt.180. ) zxlim = zxlim - 360.
               zxplus = 360.
            endif
            zlamin = latmid - 0.5*dymap/zfac
            zxadd =  1.5e-5 + xorigo - zlomin*zfac
            zyadd =  1.5e-5 + yorigo - zlamin*zfac
c
         endif
c
c------------------------------------------------------------------------------
c
c         map projection is lat/long with shifted pole
c
      else if( maprep.eq.10 ) then
c
            zfac = zradi*rearth/(scale*1.e+6)*100.0
            if( ltotal ) then
               zlomin = alonw
               zlamin = alats
            else
               zlatg = fiprim(latmid,lonmid,alatnp)
               zlong = alampr(latmid,lonmid,alatnp)
               zlomin = zlong - 0.5*dxmap/zfac
               zlamin = zlatg - 0.5*dymap/zfac
            endif
            zxadd =  1.5e-5 + xorigo - zlomin*zfac
            zyadd =  1.5e-5 + yorigo - zlamin*zfac
c
c------------------------------------------------------------------------------
c
c         map projection is rikets koordinater
c
      else if( maprep.eq.98 ) then
c
            zfac = 1./(scale*1.e+6)*100.0
            if( ltotal ) then
               zlomin = alonw
               zlamin = alats
            else
               call grerik(latmid,lonmid,zlamid,zlomid)
               zlomin = zlomid - 0.5*dxmap/zfac
               zlamin = zlamid - 0.5*dymap/zfac
            endif
            zxadd =  1.5e-5 + xorigo - zlomin*zfac
            zyadd =  1.5e-5 + yorigo - zlamin*zfac
c
c------------------------------------------------------------------------------
c
c         map projection is kulan
c
      else if( maprep.eq.30 ) then
c
            zfac = rearth/(scale*1.e+6)*100.0
            zxadd = 0.5*dxmap + xorigo + 1.e-5
            zyadd = 0.5*dymap + yorigo + 1.e-5
c
c------------------------------------------------------------------------------
c
      else
c
         write(lulog,*)' coastlines in projection ',maprep
         write(lulog,*)' not yet implemented!!!!!!!'
         return
c
      endif
c
c****************************************************************************
c
  900 read(18,iostat=ios)xplot,yplot
      if( ios.ne.0 ) goto 9998
      kvec = 1
  910 nvec = nint(xplot(kvec))
      if( nvec.lt.0 ) goto 900
c
      if( dline ) then
         do 915 lvec=kvec+1,kvec+nvec
         if( xplot(lvec).lt.zxlim )
     x          xplot(lvec) = xplot(lvec) + zxplus
  915    continue
      endif
c
      if( maprep.eq.30 ) then
         do 1005 lvec=kvec+1,kvec+nvec
         call kulan(yplot(lvec),xplot(lvec),x,y,latmid,lonmid,strch)
         xplot(lvec) = x
         yplot(lvec) = y
 1005    continue
      endif
c
 1007 continue
c
      do 1010 lvec=kvec+1,kvec+nvec
      xplot(lvec) = xplot(lvec)*zfac + zxadd
      yplot(lvec) = yplot(lvec)*zfac + zyadd
 1010 continue
c
      kstart = kvec + 1
      nlen = nvec
c
 1015 continue
c
      if( maprep.eq.30 ) then
         call infrnt(xplot(kstart),yplot(kstart),nlen,
     x                zxadd,zyadd,zfac,n1,n2,xsave,ysave)
      else
         call inline(xplot(kstart),yplot(kstart),nlen,
     x            xmin,xmax,ymin,ymax,
     x            n1,n2,xsave,ysave)
      endif
c
      if( n2-n1+1.gt.1 ) then
         xplot(kvec+n2+1) = 0.
         xplot(kvec+n2+2) = 1.
         yplot(kvec+n2+1) = 0.
         yplot(kvec+n2+2) = 1.
         if(lnewsha.and.n2-n1+1.ge.3) then
           write(31,*) n2-n1+1
           do nxyh = kstart+n1-1,kstart+n2-1
             write(31,*) xplot(nxyh),yplot(nxyh)
           enddo
         endif
         call linex(xplot(kstart+n1-1),yplot(kstart+n1-1),
     x              n2-n1+1,ltype)
      endif
c
      if( n1.gt.1 ) then
         xplot(kstart+n1-1) = xsave
         yplot(kstart+n1-1) = ysave
         nlen = n1
         goto 1015
      endif
c
      kvec = kvec + nvec + 3
      goto 910
c
 9998 close(unit=18)
      return
      end
