c-----------------------------------------------------------------------
c    type:        subroutine weekday
c    func:        calculates weekday from date (fails after year 2000)
c    system:      metgraf
c    author:      per kllberg mf
c    date:
c
c    call weekday(iyear,imonth,iday,dayname,lholy)
c
c    where
c
c    variable dim  type (i/o/w)	 content
c    -------- ---  ---- ------    -------
c    iyear           i   (i)      year (e.g. 91 or 1991)
c    imoth           i   (i)      month
c    iday            i   (i)      day in month
c    dayname(*9)     c   (o)      weekday
c    lholy           l   (o)      true for sundays.
c
c    called subroutines: none
c
c-----------------------------------------------------------------------
      subroutine weekday(iyear,imonth,iday,dayname,lholy)

      integer iyear,imonth,iday,iweekd,ce,y,dn,g,x,p
      logical lholy
      character*9 day(7),dayname

      data day/'Monday','Tuesday','Wednesday','Thursday',
     +         'Friday','Saturday','Sunday'/

      lholy = .false.

      if (iyear.lt.50) then
         iyr = iyear+2000
      else if (iyear.le.99) then
         iyr = iyear+1900
      else
         iyr = iyear
      endif

      ce = iyr/100 + 1
      y  = iyr
      if (imonth.lt.3) y = y - 1
      i  = imonth + 9
      dn = (153*mod(i,12)+2)/5 + iday
      i  = (5*y)/4 - (3*ce)/4 + 2
      sd = mod(i,7)
      i  = dn + sd
      if (mod(i,7).eq.0.or.dn.eq.300.or.
     +    dn.eq.301.or.dn.eq.307) then
        lholy = .true.
      else
        g = mod(y,19) + 1
        x = (3*ce)/4 - 12
        i = 11*g + (8*ce+5)/25 + 15 - x
        e = mod(i,30)
        if (e.eq.25.and.g.gt.11) e = e + 1
        if (e.eq.24            ) e = e + 1
        p = 44 - e
        if (e.gt.23) p = p + 30
        i = p + sd
        p = p + 7 - mod(i,7)
        if (dn.eq.p-3.or.dn.eq.p-2.or.dn.eq.p+1.or.
     +      dn.eq.p+26.or.dn.eq.p+39.or.dn.eq.p+50)
     +    lholy = .true.
      endif
      i       = dn + sd + 6
      iweekd  = mod(i,7) + 1
      dayname = day(iweekd)

      return
      end
