c     +----------------------------------------------------------------+
c     + subroutine addbox : add analyses from all boxes                +
c     +   note. this subroutine is 'hard-coded' for using 9 boxes,     +
c     +         11x11 each, 2 overlap points at each boundary,   ,     +
c     +         21x21 for full fields.                                 +
c     +----------------------------------------------------------------+
      subroutine addbox(xx,idim,jdim,f)

      implicit none
      integer idim,jdim,i,j
      real f(idim,jdim),xx(11,11,3,3)

      do j=1,5
      do i=1,5
         f(   i,   j) = xx(  i,  j,1,1)
         f(16+i,   j) = xx(6+i,  j,3,1)
         f(   i,16+j) = xx(  i,6+j,1,3)
         f(16+i,16+j) = xx(6+i,6+j,3,3)
         f(5 +i,   j)=((7-i)*xx(5+i,  j,1,1)+(  i)*xx(  i,  j,2,1))/7.
         f(11+i,   j)=((6-i)*xx(6+i,  j,2,1)+(1+i)*xx(1+i,  j,3,1))/7.
         f(5 +i,16+j)=((7-i)*xx(5+i,6+j,1,3)+(  i)*xx(  i,6+j,2,3))/7.
         f(11+i,16+j)=((6-i)*xx(6+i,6+j,2,3)+(1+i)*xx(1+i,6+j,3,3))/7.
         f(   i, 5+j)=((7-j)*xx(  i,5+j,1,1)+(  j)*xx(  i,  j,1,2) )/7.
         f(   i,11+j)=((6-j)*xx(  i,6+j,1,2)+(1+j)*xx(  i,1+j,1,3) )/7.
         f(16+i, 5+j)=((7-j)*xx(6+i,5+j,3,1)+(  j)*xx(6+i,  j,3,2) )/7.
         f(16+i,11+j)=((6-j)*xx(6+i,6+j,3,2)+(1+j)*xx(6+i,1+j,3,3) )/7.
         f( 5+i, 5+j)=((7-i)*((7-j)*xx(5+i,5+j,1,1)
     +                       +(  j)*xx(5+i,  j,1,2))/7.
     +               + (  i)*((7-j)*xx(  i,5+j,2,1)
     +                       +(  j)*xx(  i,  j,2,2))/7.)/7.
         f( 5+i,11+j)=((7-i)*((6-j)*xx(5+i,6+j,1,2)
     +                       +(1+j)*xx(5+i,1+j,1,3))/7.
     +               + (  i)*((6-j)*xx(  i,6+j,2,2)
     +                       +(1+j)*xx(  i,1+j,2,3))/7.)/7.
         f(11+i, 5+j)=((6-i)*((7-j)*xx(6+i,5+j,2,1)
     +                       +(  j)*xx(6+i,  j,2,2))/7.
     +               + (1+i)*((7-j)*xx(1+i,5+j,3,1)
     +                       +(  j)*xx(1+i,  j,3,2))/7.)/7.
         f(11+i,11+j)=((6-i)*((6-j)*xx(6+i,6+j,2,2)
     +                       +(1+j)*xx(6+i,1+j,2,3))/7. 
     +               + (1+i)*((6-j)*xx(1+i,6+j,3,2)
     +                       +(1+j)*xx(1+i,1+j,3,3))/7.)/7.
      enddo
      enddo

      do j=1,5
         f(11,j) = (xx(11,j, 1, 1) + 6.*xx( 6,j, 2, 1) + 
     +            xx( 1,j, 3, 1) )/8.
         f(11,16+j) = (xx(11,6+j, 1, 3) + 6.*xx( 6,6+j, 2, 3) + 
     +            xx( 1,6+j, 3, 3) )/8.
	 f(11,5+j) = 
     +          (  ((7-j)*xx(11,5+j,1,1)+j*xx(11,j,1,2) )/7. +
     +           6*((7-j)*xx( 6,5+j,2,1)+j*xx( 6,j,2,2) )/7. +
     +             ((7-j)*xx( 1,5+j,3,1)+j*xx( 1,j,3,2) )/7. )/8.
	 f(11,11+j) =
     +          (  ((6-j)*xx(11,6+j,1,2)+(1+j)*xx(11,1+j,1,3) )/7. +
     +           6*((6-j)*xx( 6,6+j,2,2)+(1+j)*xx( 6,1+j,2,3) )/7. +
     +             ((6-j)*xx( 1,6+j,3,2)+(1+j)*xx( 1,1+j,3,3) )/7. )/8.
      enddo

      do i=1,5
         f( i,11) = (1.*xx( i,11, 1, 1) + 6.*xx( i, 6, 1, 2) + 
     +            1.*xx( i, 1, 1, 3) )/8.
         f(16+i,11) = (1.*xx(6+i,11, 3, 1) + 6.*xx(6+i, 6, 3, 2) + 
     +            1.*xx(6+i, 1, 3, 3) )/8.
	 f(5+i,11) =
     +          (  ((7-i)*xx(5+i,11,1,1)+i*xx(i,11,2,1) )/7. +
     +           6*((7-i)*xx(5+i, 6,1,2)+i*xx(i, 6,2,2) )/7. +
     +             ((7-i)*xx(5+i, 1,1,3)+i*xx(i, 1,2,3) )/7. )/8.
         f(11+i,11) =
     +          (  ((6-i)*xx(6+i,11,2,1)+(1+i)*xx(1+i,11,3,1) )/7. +
     +           6*((6-i)*xx(6+i, 6,2,2)+(1+i)*xx(1+i, 6,3,2) )/7. +
     +             ((6-i)*xx(6+i, 1,2,3)+(1+i)*xx(1+i, 1,3,3) )/7. )/8.
      enddo

      f(11,11) = 
     +  ( 1.*xx(11, 1,1,3) + 6.*xx( 6, 1,2,3) + 1.*xx( 1, 1,3,3) +
     +    6.*xx(11, 6,1,2) +36.*xx( 6, 6,2,2) + 6.*xx( 1, 6,3,2) +
     +    1.*xx(11,11,1,1) + 6.*xx( 6,11,2,1) + 1.*xx( 1,11,3,1) ) /64.

      return
      end
